    import Assembly from 'pvbid-sdk/src/domain/Assembly.js'

public class | source

# Assembly

#### Extends:

eventemitter3~EventEmitter → AdvanceEventEmitter → BidEntity → Assembly

Assembly Class

## Constructor Summary

Public Constructor
public | constructor(assemblyData: object, bid: Bid) Creates an instance of Assembly. |

## Member Summary

Public Members
public | bid: Bid Reference to the bid that the assembly belongs to. |
public get | config: object |
public get | definitionId: number |

## Method Summary

Public Methods
public | dirty() Flags the assembly and corresponding bid as dirty and to be saved. |
public | removeBidEntity(type: string, id: number | string) Removes a bid entity from the assembly. |

## Inherited Summary

From class AdvanceEventEmitter
public | maxEvents: number Maximum number of events fired for the requester before events stop. |
public | on(eventName: string, requesterId: string, callback: function) |
public | onDelay(eventName: string, ms: number, requesterId: string, callback: function) |
public | removeListenerByRequester(eventName: string, requesterId: string) Removes event listeners by event and requesterId. |

From class BidEntity
public get | id: number Gets the id of the bid entity. |
public get | title: string Gets the bid entity title. |
public set | title: string Sets the bid entity title. |
public get | type: string Gets the bid entity type. |
public abstract | assess(dependency: BidEntity) Assesses bid entity. |
public | dependants(): BidEntity[] Gets an array of depndants that rely on the bid entity. |
public | dependencies(): BidEntity[] Gets all the dependencies that the bid entity relies on. |
public | dirty() Flags the bid entity as dirty and to be saved. |
public | exportData(): object Exports the internal data for the bid entity. |
public | hasNullDependency(field: string): boolean Determines if bid entity relies on a null or undefined dependency value |
public | isDirty(): boolean Determines of bid entity is dirty. |
public | pristine() Marks the bid entity as clean. |

## Public Constructors

### public constructor(assemblyData: object, bid: Bid) source

Creates an instance of Assembly.

#### Override:

BidEntity#constructor

#### Params:

Name | Type | Attribute | Description
assemblyData | object |  |
bid | Bid |  |

## Public Members

### public bid: Bid source

Reference to the bid that the assembly belongs to.

### public get config: object source

### public get definitionId: number source

## Public Methods

### public dirty() source

Flags the assembly and corresponding bid as dirty and to be saved.

#### Override:

BidEntity#dirty

### public removeBidEntity(type: string, id: number | string) source

Removes a bid entity from the assembly.

#### Params:

Name | Type | Attribute | Description
type | string |  |
id | number | string |  |